=== debian/changelog ===
ausweisapp2 (2.0.1-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Thu, 04 Jan 2024 13:40:03 +0100

ausweisapp2 (2.0.1-1) unstable; urgency=medium

  * New upstream release

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Mon, 18 Dec 2023 21:46:36 +0100

ausweisapp2 (2.0.0-1) unstable; urgency=medium

  * New upstream release (Closes: #1057624)
  * Drop 0001-Fix-FTBFS-with-Qt-6.6.patch, fixed upstream
  * Drop 0002-Update-QML-for-Qt-6.6.patch, fixed upstream
  * Rename ausweisapp2 binary package to ausweisapp in debian/control
  * Add Breaks and Replaces for ausweisapp2 binary package in debian/control
  * Provide transitional ausweisapp2 dummy package in debian/control
  * Add file list for ausweisapp binary package as debian/ausweisapp.install
  * Update installation path for application icon file in debian/rules

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Fri, 15 Dec 2023 23:53:45 +0100
