=== debian/changelog ===
ausweisapp2 (2.0.2-1) unstable; urgency=medium

  * New upstream release

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Sat, 13 Jan 2024 12:50:34 +0100
