=== debian/changelog ===
ausweisapp2 (2.0.3-1) unstable; urgency=medium

  * New upstream release

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Tue, 23 Jan 2024 15:18:45 +0100
